<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="库存地点" prop="storageLocationId">
        <el-select v-model="formData.storageLocationId" clearable placeholder="请选择">
          <el-option
            v-for="item in storageLocationList"
            :key="item.id"
            :label="item.storageLocationName"
            :value="item.id!"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="库区" prop="storageAreaId">
        <el-select v-model="formData.storageAreaId" clearable placeholder="请选择">
          <el-option
            v-for="item in storageAreaList"
            :key="item.id"
            :label="item.name"
            :value="item.id!"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="货架" prop="shelvesId">
        <el-select v-model="formData.shelvesId" clearable placeholder="请选择">
          <el-option
            v-for="item in shelvesList"
            :key="item.id"
            :label="item.name"
            :value="item.id!"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="货位编码" prop="code">
        <el-input v-model="formData.code" placeholder="请输入货位编码" />
      </el-form-item>
      <el-form-item label="货位名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入货位名称" />
      </el-form-item>
      <el-form-item label="显示顺序" prop="sort">
        <el-input-number v-model="formData.sort" :min="0" controls-position="right" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotCargoLocationApi, IotCargoLocationVO } from '@/api/pms/iotcargolocation'
import * as SapOrgApi from "@/api/system/saporg";
import * as IotStorageAreaApi from "@/api/pms/iotstoragearea";
import * as IotShelvesApi from "@/api/pms/iotshelves";

/** PMS 货位 表单 */
defineOptions({ name: 'IotCargoLocationForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const storageLocationList = ref([] as SapOrgApi.SapOrgVO[]) // 库存地点列表
const storageAreaList = ref([] as IotStorageAreaApi.IotStorageAreaVO[]) // 库存地点区域列表
const shelvesList = ref([] as IotShelvesApi.IotShelvesVO[]) // 货架列表

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deptId: undefined,
  factoryId: undefined,
  factoryCode: undefined,
  costCenterId: undefined,
  costCenterCode: undefined,
  storageLocationId: undefined,
  storageLocationCode: undefined,
  shelvesId: undefined,
  storageAreaId: undefined,
  code: undefined,
  name: undefined,
  type: undefined,
  row: undefined,
  layer: undefined,
  column: undefined,
  capacity: undefined,
  currentUsage: undefined,
  sort: undefined,
  status: undefined,
  remark: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotCargoLocationApi.getIotCargoLocation(id)
    } finally {
      formLoading.value = false
    }
  }
  // 加载库存地点(SAP)列表
  storageLocationList.value = await SapOrgApi.SapOrgApi.getSimpleSapOrgList(3)
  // 加载库区列表
  storageAreaList.value = await IotStorageAreaApi.IotStorageAreaApi.getSimpleStorageAreaList()
  // 加载货架列表
  shelvesList.value = await IotShelvesApi.IotShelvesApi.getSimpleShelvesList()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotCargoLocationVO
    if (formType.value === 'create') {
      await IotCargoLocationApi.createIotCargoLocation(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotCargoLocationApi.updateIotCargoLocation(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deptId: undefined,
    factoryId: undefined,
    factoryCode: undefined,
    costCenterId: undefined,
    costCenterCode: undefined,
    storageLocationId: undefined,
    storageLocationCode: undefined,
    shelvesId: undefined,
    code: undefined,
    name: undefined,
    type: undefined,
    row: undefined,
    layer: undefined,
    column: undefined,
    capacity: undefined,
    currentUsage: undefined,
    sort: undefined,
    status: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>
